#ifndef _GX_H_
#define _GX_H_

#define  GXERR_NONE              0                                               //  
#define  GXERR_NO_DEVICE         -1                                              // ġ 
#define  GXERR_ACCESS_DEVICE     -2                                              //   
#define  GXERR_VSCREEN_INFO      -3                                              // FBIOGET_VSCREENINFO  
#define  GXERR_FSCREEN_INFO      -4                                              // FBIOGET_FSCREENINFO  
#define  GXERR_MEMORY_MAPPING    -5                                              //   ޸ ο 
#define  GXERR_NOFILE            -6                                              // ̹  
#define  GXERR_HEADER_INFO       -7                                              // ̹   ̻
#define  GXERR_READ_FILE         -8                                              // ̹  б ̻
#define  GXERR_PALETTE_INFO      -9                                              // ȷƮ  ̻
#define  GXERR_COLOR_DEPTH       -10                                             // Į ̰ ǥ ƴ
#define  GXERR_NO_FONT_FILE      -11                                             // Ʈ ų   

#define  CLR_CLEAR               0x8000000                                       //  ʴ 
#define  CLR_BLACK               0x00                                            //  

#define  DCTYPE_SCREEN           1                                               // DC Type  Screen DC 

typedef struct color_t_ color_t;
struct color_t_
{
   unsigned char  red;
   unsigned char  green;
   unsigned char  blue;
};

typedef struct frame_buffer_t_ frame_buffer_t;
struct frame_buffer_t_
{
   int      fd;                                                                  //  ۿ   ũ
   int      width;                                                               // Ʈ  
   int      height;                                                              // Ʈ  
   int      dots;                                                                // ü Ʈ  width * height
   int      bytes;                                                               // ޸ ü ũ
   int      colors;                                                              // Į , 1=1bit, 4=4bit, 8=8bit, ...
   int      bytes_per_line;                                                      // δ Ʈ 
   int      bits_per_pixel;                                                      // Ʈ ȼ 

   unsigned short *mapped;                                                       // ޸ ε 
};

typedef struct dc_t_ dc_t;
struct dc_t_
{
   char     dc_type;                                                             // DC · Screen, Bitmap Ѵ.
   int      width;                                                               // Ʈ  
   int      height;                                                              // Ʈ  
   int      dots;                                                                // ü Ʈ  width * height
   int      bytes;                                                               // ޸ ü Byte ũ
   int      colors;                                                              // Į 
   int      bytes_per_line;                                                      // δ Ʈ 
   int      bits_per_pixel;                                                      // Ʈ ȼ 
   int      coor_x;                                                              //  ׸ ߴ  ǥ
   int      coor_y;                                                              //  ׸ ߴ  ǥ
   int      pen_color;                                                           //   Į
   int      brush_color;                                                         //  귯 Į
   void    *mapped;                                                              // ޸ ε 

   void (*release_dc)( dc_t *dc);                                                // Device Context Ҹ   ޸𸮸 
   int  (*color    )( int red, int green, int blue);                             // Į ϱ
   void (*clear    )( dc_t *dc, int color);                                      //  ü ĥϱ
   void (*get_pixel)( dc_t *dc, int coor_x, int coor_y, color_t   *color );      // Į  о 
   void (*set_pixel)( dc_t *dc, int coor_x, int coor_y, int color        );      //  
   void (*hline    )( dc_t *dc, int x1st  , int x_2nd , int coor_y, int color);  //  ߱
   void (*vline    )( dc_t *dc, int coor_x, int y_1st , int y_2nd , int color);  //  ߱
};

extern         frame_buffer_t  gx_fb;                                            //   

extern int     gx_init         ( char *devName);                                 // ׷ ̺귯 ʱȭ
extern void    gx_close        ( void);                                          // ׷ ̺귯  
extern dc_t   *gx_get_screen_dc( void);                                          // ȭ dc 
extern dc_t   *gx_get_buffer_dc(  int width,int height);                         // ȭ    DC 
extern void    gx_release_dc   ( dc_t *dc);                                      // dc  Ҹ

extern int     gx_color      ( dc_t *dc, int red, int green, int blue);          // Į  
extern void    gx_clear      ( dc_t *dc, int color);                             // Ư  ü ĥ
extern void    gx_pen_color  ( dc_t *dc, int color);                             // pen Į 
extern void    gx_brush_color( dc_t *dc, int color);                             // brush Į 
extern void    gx_get_pixel  ( dc_t *dc, int coor_x, int coor_y, color_t  *color);  // Į  о 
extern void    gx_set_pixel  ( dc_t *dc, int coor_x, int coor_y, int color);     // dc  
extern void    gx_move_to    ( dc_t *dc, int coor_x, int coor_y);                // dc ǥ ̵
extern void    gx_line_to    ( dc_t *dc, int coor_x, int coor_y);                // dc ǥ  ǥ  ׸
extern void    gx_line       ( dc_t *dc, int x1, int y1, int x2, int y2);        // dc  ׸
extern void    gx_border     ( dc_t *dc, int x1, int y1, int x2, int y2);        // 簢 ׵θ
extern void    gx_box        ( dc_t *dc, int x1, int y1, int x2, int y2);        // ΰ ä 簢
extern void    gx_rectangle  ( dc_t *dc, int x1, int y1, int x2, int y2);        // dc 簢 ׸
extern void    gx_circle     ( dc_t *dc, int xCenter, int yCenter, int Radius);  //  
extern void    gx_ellipse    ( dc_t *dc, int xCenter, int yCenter,               // Ÿ 
                                         int width,  int height);
extern void    gx_bitblt     ( dc_t *dcDest, int xDest, int yDest, dc_t *dcSour, // dc  ٸ dc  
                                             int xSour, int ySour, int wSour, int hSour);
extern void    gx_to_screen_dc( dc_t *dcScreen, dc_t *dcBuffer);                 // DCTYPE_SCREEN dc ٸ DCTYPE_SCREEN dc ü 

#endif
