#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <gx.h>
#include <gxbmp.h>

#define BI_RGB          0
#define BI_RLE4         1
#define BI_RLE8         2
#define BI_BITFIELD     3

/********************************************************************* 1 pixel */

// : Į  Ѵ.
static int   b1_color(  int red,                                                 // 0 255  red   
                        int green,                                               // 0 255  green 
                        int blue                                                 // 0 255  blue  
                     )
{
   if ( 0 == red +green +blue)
      return   0;
   else
      return   1;
}

static void  b1_clear( bitmap_t *bmp, int color)
{
   printf( "ؾ \n");
   bmp = bmp; color = color;
}

static void b1_get_pixel( bitmap_t *bmp, int coor_x, int coor_y, color_t *color)
{
   unsigned char *pdata;
   int            offset = (bmp->height -coor_y -1) * bmp->bytes_per_line + (coor_x /8);
   int            pixel1;
   int            boffset;

   pdata    = bmp->data + offset;
   boffset  = coor_x %8;
   pixel1   = (*pdata & (0x80U >> boffset)) >> (7-boffset);

   /* palette lookup */
   color->blue    = bmp->palette[pixel1].blue;
   color->green   = bmp->palette[pixel1].green;
   color->red     = bmp->palette[pixel1].red;
}

static void b1_set_pixel( bitmap_t *bmp, int coor_x, int coor_y, int color)
{
   printf( "ؾ \n");
   bmp = bmp;     coor_x = coor_x;    coor_y = coor_y;    color = color;
}

static void  b1_hline( bitmap_t *bmp, int x1st, int x_2nd, int coor_y, int color)
// :  ׸.
{
   printf( "ؾ \n");
   bmp = bmp;  x1st = x1st;   x_2nd = x_2nd;   coor_y = coor_y;    color = color;
}

static void  b1_vline( bitmap_t *bmp, int coor_x, int y_1st, int y_2nd, int color)
// :  ׸.
{
   printf( "ؾ \n");
   bmp = bmp;  coor_x = coor_x; y_1st = y_1st;   y_2nd = y_2nd;    color = color;
}

/********************************************************************* 4 pixel */

// : Į  Ѵ.
static int   b4_color(  int red,                                                 // 0 255  red   
                        int green,                                               // 0 255  green 
                        int blue                                                 // 0 255  blue  
                     )
{
   if ( 0 == red + green +blue)
      return   0;
   else
      return   1;
}

static void  b4_clear( bitmap_t *bmp, int color)
{
   printf( "ؾ \n");
   bmp = bmp; color = color;
}
static void b4_get_pixel( bitmap_t *bmp, int coor_x, int coor_y, color_t *color)
{
   unsigned char *pdata;
   int            offset = ( bmp->height -coor_y -1) * bmp->bytes_per_line + ( coor_x>>1);
   int            pixel4;
   int            boffset;

   pdata    = bmp->data + offset;
   boffset  = ( coor_x & 0x01) << 2;

   pixel4   = (*pdata & (0xF0U >> boffset)) >> (4-boffset);

   /* palette lookup */
   color->blue    = bmp->palette[pixel4].blue;
   color->green   = bmp->palette[pixel4].green;
   color->red     = bmp->palette[pixel4].red;
}

static void b4_set_pixel( bitmap_t *bmp, int coor_x, int coor_y, int color)
{
   bmp = bmp;  coor_x = coor_x;  coor_y = coor_y;  color = color;
}

static void  b4_hline( bitmap_t *bmp, int x1st, int x_2nd, int coor_y, int color)
// :  ׸.
{
   printf( "ؾ \n");
   bmp = bmp;  x1st = x1st;   x_2nd = x_2nd; coor_y = coor_y;  color = color;
}

static void  b4_vline( bitmap_t *bmp, int coor_x, int y_1st, int y_2nd, int color)
// :  ׸.
{
   printf( "ؾ \n");
   bmp = bmp;  coor_x = coor_x;  y_1st = y_1st; y_2nd = y_2nd; color = color;
}

/********************************************************************* 8 pixel */

// : Į  Ѵ.
static int   b8_color(  int red,                                                 // 0 255  red   
                        int green,                                               // 0 255  green 
                        int blue                                                 // 0 255  blue  
                     )
{
   if ( 0 == red +green +blue)
      return   0;
   else
      return   1;
}

static void  b8_clear( bitmap_t *bmp, int color)
{
   printf( "ؾ \n");
   bmp = bmp; color = color;
}
static void b8_get_pixel( bitmap_t *bmp, int coor_x, int coor_y, color_t *color)
{
   unsigned char *pdata;
   int            offset = (bmp->height -coor_y -1) *bmp->bytes_per_line +coor_x;
   int            pixel8;

   pdata          = bmp->data +offset;
   pixel8         = *pdata;

   /* palette lookup */

   color->blue    = bmp->palette[pixel8].blue;
   color->green   = bmp->palette[pixel8].green;
   color->red     = bmp->palette[pixel8].red;
}

static void b8_set_pixel( bitmap_t *bmp, int coor_x, int coor_y, int color)
{
   bmp = bmp;  coor_x = coor_x;  coor_y = coor_y;  color = color;
}

static void  b8_hline( bitmap_t *bmp, int x1st, int x_2nd, int coor_y, int color)
// :  ׸.
{
   printf( "ؾ \n");
   bmp = bmp;  x1st = x1st;   x_2nd = x_2nd;   coor_y = coor_y;    color = color;
}

static void  b8_vline( bitmap_t *bmp, int coor_x, int y_1st, int y_2nd, int color)
// :  ׸.
{
   printf( "ؾ \n");
   bmp = bmp;  coor_x = coor_x; y_1st = y_1st;   y_2nd = y_2nd;    color = color;
}

/******************************************************************** 16 pixel */

static int   b16_color( int red,                                                 // 0 255  red   
                        int green,                                               // 0 255  green 
                        int blue                                                 // 0 255  blue  
                        )
// : Į  Ѵ.
// : 16 bit ȯ濡  shift=0:5:6:5, shift=0:11:5:0
// : red, green, blue  Ʒ  ؾ Ǵ. ׷  ӵ  Ϲ  ġȯߴ.
//   red   >>= 8-bmp->bsize_red;
//   green >>= 8-bmp->bsize_green;
//   blue  >>= 8-bmp->bsize_blue;
//   return   ( red << bmp->boffset_red) | ( green << bmp->boffset_green) | blue << bmp->boffset_blue;
{
   red   >>= 3;
   green >>= 3;
   blue  >>= 3;

   return   ( red << 10) | ( green << 5) | blue;
}
static void  b16_clear( bitmap_t *bmp,                                            // Bitmap DC
                        int color                                                // 
                      )
// : Bitmap DC    ä.
{
   int             ndx;
   unsigned short *ptr;

   if ( CLR_CLEAR > color)
   {
      ptr = (unsigned short *)bmp->data;

      for ( ndx = 0; ndx < bmp->dots; ndx++)
         *ptr++ = color;
   }
}

static void b16_get_pixel( bitmap_t *bmp, int coor_x, int coor_y, color_t *color)
{
   unsigned short *pdata;
   int             offset  = (bmp->height -coor_y -1) *bmp->bytes_per_line +( coor_x << 1);
   unsigned       *mask    = (unsigned *)( bmp->palette);

   pdata = (unsigned short *)(bmp->data +offset);

   color->blue    = ((*pdata & mask[2]) >> bmp->boffset_blue ) << (8-bmp->bsize_blue );
   color->green   = ((*pdata & mask[1]) >> bmp->boffset_green) << (8-bmp->bsize_green);
   color->red     = ((*pdata & mask[0]) >> bmp->boffset_red  ) << (8-bmp->bsize_red  );
}

static void b16_set_pixel( bitmap_t *bmp, int coor_x, int coor_y, int color)
{
   unsigned short *pdata;
   int             offset = (bmp->height -coor_y -1) *bmp->bytes_per_line +( coor_x << 1);

   pdata = (unsigned short *)(bmp->data +offset);
  *pdata = color;
}


static void  b16_hline( bitmap_t *bmp,                                           // Bitmap DC
                        int       x1st, int x_2nd,                               //  ߱  x ǥ
                        int       coor_y,                                        //  ߱  y ǥ
                        int       color                                          //  
                      )
// :  ׸.
{
   unsigned short *ptr;
   int             ndx;

   if ( 0 > coor_y || bmp->height <= coor_y)                                     // y ·ᰡ ũ   
      return;

   if ( x_2nd < x1st)                                                             // x ǥ  ǥ ۰ 
   {
      ndx      = x1st;
      x1st     = x_2nd;
      x_2nd    = ndx;
   }

   if       ( 0          >  x1st)  x1st   = 0;                                   //  ȭ  ǥ̸ 0 ׸.
   else if  ( bmp->width <= x1st)  x1st   = bmp->width-1;                        //  ȭ  ǥ̸  ȭ ׸.

   if       ( 0          >  x_2nd)  x_2nd   = 0;
   else if  ( bmp->width <= x_2nd)  x_2nd   = bmp->width-1;

   ptr   = (unsigned short *)bmp->mapped + bmp->width *( bmp->height -coor_y) +x1st;
   for ( ndx = x1st; ndx <= x_2nd; ndx++)
     *ptr++ = color;
}

static void  b16_vline( bitmap_t *bmp,                                           // Bitmap DC
                        int       coor_x,                                        //  ߱  x ǥ
                        int       y_1st, int y_2nd,                              //  ߱  y ǥ
                        int       color                                          //  
                      )
// :  ׸.
{
   unsigned short *ptr;
   int             ndx;

   if ( 0 > coor_x || bmp->width <= coor_x)                                      // x ·ᰡ ũ   
      return;

   if ( y_2nd < y_1st)                                                           // y ǥ  ǥ ۰ 
   {
      ndx     = y_1st;
      y_1st    = y_2nd;
      y_2nd    = ndx;
   }

   if       ( 0           >  y_1st)  y_1st   = 0;                                // ȭ   ǥ̸ 0 ׸.
   else if  ( bmp->height <= y_1st)  y_1st   = bmp->height-1;                    // ȭ ϴ  ǥ̸  ȭ ׸.

   if       ( 0           >  y_2nd)  y_2nd   = 0;
   else if  ( bmp->height <= y_2nd)  y_2nd   = bmp->height-1;

   ptr   = (unsigned short *)bmp->mapped + bmp->width * ( bmp->height-y_1st) +coor_x;
   for ( ndx = y_1st; ndx <= y_2nd; ndx++)
   {
     *ptr   = color;
      ptr  -= bmp->width;
   }
}

/******************************************************************** 24 pixel */

static int b24_color(  int red,                                                  // 0 255  red   
                       int green,                                                // 0 255  green 
                       int blue                                                  // 0 255  blue  
                     )
// : Į  Ѵ.
{
   if ( 0 == red +green +blue)
      return   0;
   else
      return   1;
}

static void b24_clear( bitmap_t *bmp,                                            // Bitmap DC
                       int color                                                 // 
                     )
// : Bitmap DC    ä.
{
   printf( "ؾ \n");
   bmp = bmp; color = color;
}

static void b24_get_pixel( bitmap_t *bmp, int coor_x, int coor_y, color_t *color)
{
   unsigned char *pdata;
   int            offset = ( bmp->height -coor_y -1)*bmp->bytes_per_line +coor_x*3;

   pdata          = bmp->data + offset;
   color->blue    = *pdata;
   color->green   = *(pdata+1);
   color->red     = *(pdata+2);
}

static void b24_set_pixel( bitmap_t *bmp, int coor_x, int coor_y, int color)
{
   unsigned char *pdata;
   int            offset = ( bmp->height -coor_y -1)*bmp->bytes_per_line +coor_x*3;

   pdata          = bmp->data + offset;
  *pdata          = color;
}

static void b24_hline( bitmap_t *bmp, int x1st, int x_2nd, int coor_y, int color)
// :  ׸.
{
   printf( "ؾ \n");
   bmp = bmp;  x1st = x1st;   x_2nd = x_2nd;   coor_y = coor_y;    color = color;
}

static void b24_vline( bitmap_t *bmp, int coor_x, int y_1st, int y_2nd, int color)
// :  ׸.
{
   printf( "ؾ \n");
   bmp = bmp;  coor_x = coor_x; y_1st = y_1st;   y_2nd = y_2nd;    color = color;
}

/******************************************************************** 32 pixel */

// : Į  Ѵ.
static int   b32_color( int red,                                                 // 0 255  red   
                        int green,                                               // 0 255  green 
                        int blue                                                 // 0 255  blue  
                     )
{
   if ( 0 == red +green +blue)
      return   0;
   else
      return   1;
}

static void  b32_clear( bitmap_t *bmp, int color)
{
   printf( "ؾ \n");
   bmp = bmp; color = color;
}

static void b32_get_pixel( bitmap_t *bmp, int coor_x, int coor_y, color_t   *color)
{
   unsigned *pdata;
   unsigned *mask    = ( unsigned *)( bmp->palette);
   int       offset  = ( bmp->height -coor_y -1)*bmp->bytes_per_line +( coor_x << 2);

   pdata = (unsigned *)(bmp->data +offset);

   color->blue    = ((*pdata & mask[2]) >> bmp->boffset_blue   ) << (8-bmp->bsize_blue );
   color->green   = ((*pdata & mask[1]) >> bmp->boffset_green  ) << (8-bmp->bsize_green);
   color->red     = ((*pdata & mask[0]) >> bmp->boffset_red    ) << (8-bmp->bsize_red  );
}

static void b32_set_pixel( bitmap_t *bmp, int coor_x, int coor_y, int color)
{
   printf( "ؾ \n");
   bmp = bmp;  coor_x   = coor_x;  coor_y = coor_y;    color = color;
}

static void  b32_hline( bitmap_t *bmp, int x1st, int x_2nd, int coor_y, int color)
// :  ׸.
{
   printf( "ؾ \n");
   bmp = bmp;  x1st = x1st;   x_2nd = x_2nd;   coor_y = coor_y;    color = color;
}

static void  b32_vline( bitmap_t *bmp, int coor_x, int y_1st, int y_2nd, int color)
// :  ׸.
{
   printf( "ؾ \n");
   bmp = bmp;  coor_x = coor_x;  y_1st = y_1st; y_2nd = y_2nd; color = color;
}

/*******************************************************************************/

static void calculate_boffset(bitmap_t *bmp)
{
   int i;
   unsigned *mask = (unsigned *)(bmp->palette);
   unsigned  temp;

   /* red */
   temp = mask[0];
   for(i = 0; i < 32; i++)
   {
      if(temp & 0x01)
         break;
      temp >>= 1;
   }
   bmp->boffset_red = i;
   for(i = 0; i < 32; i++)
   {
      if(temp & 0x800000UL)
         break;
      temp <<= 1;
   }
   bmp->bsize_red = 32-i;

   /* green */
   temp = mask[1];
   for(i = 0; i < 32; i++)
   {
      if(temp & 0x01)
         break;
      temp >>= 1;
   }
   bmp->boffset_green = i;
   for(i = 0; i < 32; i++)
   {
      if(temp & 0x800000UL)
         break;
      temp <<= 1;
   }
   bmp->bsize_green = 32-i;

   /* blue */
   temp = mask[2];
   for(i = 0; i < 32; i++)
   {
      if(temp & 0x01)
         break;
      temp >>= 1;
   }
   bmp->boffset_blue = i;
   for(i = 0; i < 32; i++)
   {
      if (temp & 0x800000UL)
         break;
      temp <<= 1;
   }
   bmp->bsize_blue = 32-i;
}

static void rle8_decoding( bitmap_t *bmp)
{
   unsigned char *pdata    = bmp->data;
   unsigned char *pend     = pdata + bmp->width*bmp->height;
   unsigned char *penc_data = bmp->encoded_data;
   unsigned char  c_byte;
   int            ndx, jdx;

   while( 1 )
   {
      if(pdata >= pend)
         break;
      c_byte = *penc_data++;
      if( 0 == c_byte) /* escape */
      {
         c_byte = *penc_data++;
         if( 0 == c_byte) /* end of line */
         {
            ndx = pdata - bmp->data;
            ndx %= bmp->width;
            for( ; ndx < bmp->width; ndx++)
               pdata++;
         }
         else if( c_byte == 1) /* end of bitmap */
         {
            return;
         }
         else if( c_byte == 2) /* delta */
         {
            jdx = *penc_data++; /* right */
            ndx = *penc_data++; /* down */
            ndx = jdx +ndx *bmp->width;
            while(0 < ndx--)
               pdata++;
         }
         else /* absolute mode */
         {
            c_byte = *penc_data++;
            while( 0 < c_byte--)
               *pdata++ = *penc_data++;
            /* word boundary */
            while((unsigned)penc_data & 0x01)
               penc_data++;
         }
      }
      else
      {
         while( c_byte--)
            *pdata++ = *penc_data;
         penc_data++;
      }
   }
}

static int read_data(FILE *fp, bitmap_t *bmp)
{
   fseek(fp, bmp->data_offset, SEEK_SET);

   if (bmp->compression == BI_RGB || bmp->compression == BI_BITFIELD)
   {
      bmp->data = (unsigned char *)malloc(bmp->bitmap_size);
      fread(bmp->data, 1, bmp->bitmap_size, fp);
   }
   else
   {
      bmp->encoded_data  = (unsigned char *)malloc(bmp->bitmap_size);
      bmp->data         = (unsigned char *)malloc(bmp->width*bmp->height*bmp->bpp/8);
      memset(bmp->encoded_data, 0, bmp->bitmap_size);
      fread( bmp->encoded_data, 1, bmp->bitmap_size, fp);
      if(bmp->compression == BI_RLE4)
         return -1;                                               /* rle4_decoding is not supported ! */
      else
         rle8_decoding( bmp);
   }
   return 0;
}

static int read_palette(FILE *fp, bitmap_t *bmp)
{
   int size;

   size = fread( bmp->palette, sizeof( palette_t), bmp->cnt_palette, fp);
   if ( size != bmp->cnt_palette)
      return -1;

   return 0;
}

static int ReadHeader(FILE *fp, bitmap_t *bmp)
{
   int size;
   int remnant;
   unsigned char ID[2];

   ID[0] = fgetc( fp);                                                           // ID üũ
   ID[1] = fgetc( fp);
   if(ID[0] != 'B' || ID[1] != 'M')
      return -1;

   if ( 52 != ( size = fread( &bmp->file_size, 1, 52, fp)))                       // bmp    о δ.
      return -1;

   bmp->cnt_palette  = ( bmp->data_offset-54) >> 2;
   bmp->width        = bmp->img_width;
   bmp->height       = bmp->img_height;

   size     = bmp->img_width * bmp->bpp /8;
   remnant  = size %4;
   if (remnant == 0)
      bmp->bytes_per_line = size;
   else
      bmp->bytes_per_line = size +(4 -remnant);

   if ( 0 == bmp->bitmap_size)                                                    //   ȵ ¶ bitmap_size  0  
      bmp->bitmap_size = bmp->height*bmp->bytes_per_line;

   return 0;
}

static int set_header( bitmap_t *bmp, int width, int height, int depth, int palette_size)
{
   int size;
   int remnant;

   bmp->width        = width;
   bmp->height       = height;
   bmp->img_width    = width;
   bmp->img_height   = height;
   bmp->dots         = width * height;
   bmp->data         = NULL;
   bmp->palette      = NULL;
   bmp->compression  = BI_RGB;                                                   // BITMAP   RGB

   if ( 0 < palette_size)                                                         // ȷƮ  Ǿ ִٸ
   {
      bmp->cnt_palette  = palette_size;
      bmp->palette      = ( palette_t *)malloc( sizeof( palette_t) * bmp->cnt_palette);
      memset( bmp->palette, 0, sizeof( palette_t) * bmp->cnt_palette);
   }

   bmp->bpp = depth;
   size     = bmp->img_width * bmp->bpp /8;
   remnant  = size %4;

   if ( 0 == remnant)
      bmp->bytes_per_line = size;
   else
      bmp->bytes_per_line = size + (4-remnant);

   bmp->bitmap_size  = bmp->height * bmp->bytes_per_line;
   bmp->bytes        = bmp->bitmap_size;
   return 0;
}

static void  release_dc( dc_t *dc)
{
   bitmap_t  *bmp  = (bitmap_t *)dc;

   if ( NULL == bmp)             return;
   if ( NULL != bmp->palette)    free( bmp->palette);
   if ( NULL != bmp->data   )    free( bmp->data   );
   free( bmp);
}

static bitmap_t *setup_bitmap( bitmap_t *bmp)
{
   bmp->dc_type      = DCTYPE_BITMAP;                                            // DC ¸ BITMAP
   bmp->release_dc   = release_dc;                                                // Ҹ  Լ
   bmp->mapped       = bmp->data;                                                // ̹ κ ޸ 
   bmp->colors       = bmp->bpp;                                                 // Į 

   switch(bmp->bpp)
   {
   case  1:
            bmp->color     = b1_color;
            bmp->clear     = b1_clear;
            bmp->get_pixel = b1_get_pixel;
            bmp->set_pixel = b1_set_pixel;
            bmp->vline     = b1_vline;
            bmp->hline     = b1_hline;
            break;
   case  4:
            bmp->color     = b4_color;
            bmp->clear     = b4_clear;
            bmp->get_pixel = b4_get_pixel;
            bmp->set_pixel = b4_set_pixel;
            bmp->vline     = b4_vline;
            bmp->hline     = b4_hline;
            break;
   case  8:
            bmp->color     = b8_color;
            bmp->clear     = b8_clear;
            bmp->get_pixel = b8_get_pixel;
            bmp->set_pixel = b8_set_pixel;
            bmp->vline     = b8_vline;
            bmp->hline     = b8_hline;
            break;
   case  16:
            bmp->color     = b16_color;
            bmp->clear     = b16_clear;
            bmp->get_pixel = b16_get_pixel;
            bmp->set_pixel = b16_set_pixel;
            bmp->vline     = b16_vline;
            bmp->hline     = b16_hline;

            if( bmp->compression == BI_RGB)                                      //  BI_RGB
            {
               unsigned *mask;

               if( NULL != bmp->palette) /* something wrong */
               {
                  bmp->error_code  = GXERR_PALETTE_INFO;
                  return bmp;
               }
               mask = (unsigned *)malloc(sizeof(unsigned)*3);
               mask[2]              = 0x001F; /* blue mask */
               mask[1]              = 0x03E0; /* green mask */
               mask[0]              = 0x7C00; /* red mask */
               bmp->palette         = ( palette_t *)mask;
               bmp->boffset_blue    = 0;
               bmp->boffset_green   = 5;
               bmp->boffset_red     = 10;
               bmp->bsize_blue      = 5;
               bmp->bsize_green     = 5;
               bmp->bsize_red       = 5;
            }
            else  /* BI_BITFIELD */
            {
               if( bmp->palette == NULL) /* something wrong */
               {
                  bmp->error_code   = GXERR_PALETTE_INFO;
                  return bmp;
               }
               calculate_boffset(bmp);
            }
            break;
   case  24:
            bmp->color     = b24_color;
            bmp->clear     = b24_clear;
            bmp->get_pixel = b24_get_pixel;
            bmp->set_pixel = b24_set_pixel;
            bmp->vline     = b24_vline;
            bmp->hline     = b24_hline;
            break;
   case  32:
            bmp->color     = b32_color;
            bmp->clear     = b32_clear;
            bmp->get_pixel = b32_get_pixel;
            bmp->set_pixel = b32_set_pixel;
            bmp->vline     = b32_vline;
            bmp->hline     = b32_hline;
            if(bmp->compression == BI_RGB)
            {
               unsigned *mask;

               if( bmp->palette != NULL) /* something wrong */
               {
                  bmp->error_code   = GXERR_PALETTE_INFO;
                  return bmp;
               }

               mask                 = (unsigned *)malloc(sizeof(unsigned)*3);
               mask[2]              = 0x000000FF; /* blue mask */
               mask[1]              = 0x0000FF00; /* green mask */
               mask[0]              = 0x00FF0000; /* red mask */
               bmp->palette         = ( palette_t *)mask;
               bmp->boffset_blue    = 0;
               bmp->boffset_green   = 8;
               bmp->boffset_red     = 16;
               bmp->bsize_blue      = 8;
               bmp->bsize_green     = 8;
               bmp->bsize_red       = 8;
            }
            else /* BI_BITFILED */
            {
               if (bmp->palette == NULL) /* something wrong */
               {
                  bmp->error_code   = GXERR_PALETTE_INFO;
                  return bmp;
               }
               calculate_boffset( bmp);
            }
            break;
   default:
            bmp->error_code      = GXERR_COLOR_DEPTH;
            return bmp;
   }
   return bmp;
}

bitmap_t *gx_bmp_create( int width, int height, int depth, int palette_size)
{
   bitmap_t    *bmp;

   if ( NULL == ( bmp = malloc( sizeof( bitmap_t))) )
   {
      return NULL;
   }
   memset( bmp, 0, sizeof( bitmap_t));

   set_header( bmp, width, height, depth, palette_size);

   if ( NULL == ( bmp->data = malloc( bmp->bitmap_size)) )
   {
      return NULL;
   }

   return setup_bitmap( bmp);
}

bitmap_t *gx_bmp_open( char *file_name)
{
   FILE     *fp;
   bitmap_t    *bmp;

   if ( NULL == ( bmp = malloc( sizeof( bitmap_t))) )    return NULL;

   memset( bmp, 0, sizeof( bitmap_t));

   fp = fopen( file_name, "r+b");
   if ( NULL == ( fp) )
   {
      bmp->error_code   = GXERR_NOFILE;
      return bmp;
   }

   if ( ReadHeader( fp, bmp))
   {
      bmp->error_code   = GXERR_HEADER_INFO;
      fclose(fp);
      return bmp;
   }

   if ( 0 != bmp->cnt_palette)
   {
      bmp->palette = ( palette_t *)malloc( sizeof( palette_t) * bmp->cnt_palette);
      memset( bmp->palette, 0, sizeof( palette_t) * bmp->cnt_palette);
      if ( read_palette(fp, bmp))
      {
         bmp->error_code   = GXERR_PALETTE_INFO;
         fclose(fp);
         return bmp;
      }
   }

   if( read_data(fp, bmp))
   {
      bmp->error_code      = GXERR_READ_FILE;
      fclose(fp);
      return bmp;
   }

   return setup_bitmap( bmp);
}

void  gx_bmp_close( bitmap_t *bmp)
{
   gx_release_dc( (dc_t *)bmp);
}
