#ifndef _GX_BMP_H_
#define _GX_BMP_H_

#include <gx.h>

#define  DCTYPE_BITMAP              2                                            // DC Type  Bitmap 

typedef struct palette_t_ palette_t;
struct palette_t_
{
	unsigned char blue;
	unsigned char green;
	unsigned char red;
	unsigned char filter;
};

typedef struct bitmap_t_ bitmap_t;
struct bitmap_t_
{
   char     dc_type;                                                             // DC · Screen, Bitmap Ѵ.
   int      width;                                                               // Ʈ  
   int      height;                                                              // Ʈ  
   int      dots;                                                                // ü Ʈ  width * height
   int      bytes;                                                               // ޸ ü Byte ũ
   int      colors;                                                              // Į 
   int      bytes_per_line;                                                      // δ Ʈ 
   int      bits_per_pixel;                                                      // Ʈ ȼ 
   int      coor_x;                                                              //  ׸ ߴ  ǥ
   int      coor_y;                                                              //  ׸ ߴ  ǥ
   int      pen_color;                                                           //   Į
   int      brush_color;                                                         //  귯 Į
   void    *mapped;                                                              // ޸ ε 

   void (*release_dc)( dc_t *dc);                                                // Device Context Ҹ   ޸𸮸 
   int  (*color     )( int red, int green, int blue);								      // Į ϱ
   void (*clear	  )( bitmap_t *bmp, int color);										   //  ü ĥϱ
	void (*get_pixel )( bitmap_t *bmp, int coor_x, int coor_y, color_t *color);	// Į  о 
	void (*set_pixel )( bitmap_t *bmp, int coor_x, int coor_y, int color 	 );	//  
   void (*hline	  )( bitmap_t *bmp, int x1st  , int x_2nd , int coor_y, int color);	//  ߱
   void (*vline	  )( bitmap_t *bmp, int coor_x, int y_1st , int y_2nd , int color);	//  ߱

   int   error_code;                                                             //  ڵ

	int   file_size;                                                              // ^  ̹  
	int   reserved;                                                               // |   
	int   data_offset;                                                            // |
	int   header_size;                                                            // |
	int   img_width;                                                              // |  ̹ 
	int   img_height;                                                             // |  ̹ 
	short cnt_planes;                                                             // |  bmp   52 bytes
	short bpp;                                                                    // |
	int   compression;                                                            // |   
	int   bitmap_size;                                                            // |
	int   hres;                                                                   // |
	int   vres;                                                                   // |
	int   cnt_colors;                                                             // |
	int   important_colors;                                                       // v

	int            cnt_palette;                                                   // ȷƮ 
	palette_t     *palette;                                                       // ȷƮ Į 
	unsigned char *data;                                                          // ̹  
	unsigned char *encoded_data;
	unsigned       bsize_blue  , bsize_green  , bsize_red;                        // R,G,B   Ʈ ũ
	unsigned       boffset_blue, boffset_green, boffset_red;                      // R,G,B    ϱ  Ʈ Ƚ
};

extern bitmap_t  *gx_bmp_create( int width, int height, int Depth,               // Bitmap ü 
                                 int PaletteSize);
extern bitmap_t  *gx_bmp_open  ( char  *FileName);             	               // Bmp ü  Ŀ,  
extern void       gx_bmp_close ( bitmap_t *bmp);                                 //  Ŭ  bmp ü Ҹ

#endif
