#include    <stdio.h>
#include    <stdlib.h>
#include    <time.h>
#include    <unistd.h>                                                           // sleep
#include    <gx.h>                                                               // ⺻ ׷ ̺귯
#include    <gxbmp.h>
#include    <gxbdf.h>                                                            //   ̺귯
#include    <png.h>

#define     ERROR    -1

typedef unsigned char   uch;
typedef unsigned short  ush;
typedef unsigned int    uln;
typedef unsigned long   ulg;

int   main( void)
{
   dc_t           *dc;

   FILE          *infile;
   uch            sig[8];
   png_structp    png_ptr = NULL;
   png_infop      info_ptr = NULL;

   png_uint_32    ihdr_width, ihdr_height;
   int            width, height;
   int            bit_depth, color_type;
   png_color_16p  pBackground;

   uch            bg_red =0, bg_green=0, bg_blue=0;
   uch           *image_data = NULL;
   int            image_channels, image_rowbytes;
   double         display_exponent  = 1.0 * 2.2;

   double         gamma;
   png_uint_32    rowbytes;
   png_bytepp     row_pointers = NULL;
   int            i;

   //////////////////////////////////////////////////////////////////////////////

   gx_init( "/dev/fb");
   dc = gx_get_screen_dc();
   gx_clear( dc, gx_color( dc, 0, 0, 0));
   dc->pen_color = gx_color( dc, 255, 255, 255);
   gx_line( dc, 0, 0, dc->width, dc->height);

   //////////////////////////////////////////////////////////////////////////////

   infile = fopen( "pngout.png", "rb");
   fread(sig, 1, 8, infile);
   if ( !png_check_sig(sig, 8))  printf( "bad signature\n");
   else
   {
      png_ptr = png_create_read_struct( PNG_LIBPNG_VER_STRING, NULL, NULL, NULL); //    ڵ鷯  NULL 
      if ( !png_ptr)    printf( "out of memory\n");
      else
      {
         info_ptr = png_create_info_struct( png_ptr);
         if (!png_ptr)     printf( "out of memory\n");
         else
         {
            if ( setjmp( png_jmpbuf(png_ptr)))
            {
               png_destroy_read_struct(&png_ptr, &info_ptr, NULL);
               printf( "for bad IHDR");
            }
            else
            {
               png_init_io( png_ptr, infile);
               png_set_sig_bytes( png_ptr, 8);                                   // we already read the 8 signature bytes
               png_read_info( png_ptr, info_ptr);                                // read all PNG info up to image data

               /* alternatively, could make separate calls to png_get_image_width(),
                * etc., but want bit_depth and color_type for later [don't care about
                * compression_type and filter_type => NULLs] */

               png_get_IHDR(png_ptr, info_ptr, &ihdr_width, &ihdr_height, &bit_depth, &color_type, NULL, NULL, NULL);
               width    = ihdr_width;
               height   = ihdr_height;
               printf( "width     = %u\n", width      );
               printf( "height    = %u\n", height     );
               printf( "bit depth = %d\n", bit_depth  );
               printf( "color type= %d\n", color_type );

               //׶ Į Ѵ. Ǵ ڰ      ⼭ 

               if ( setjmp(png_jmpbuf( png_ptr))) {
                   png_destroy_read_struct(&png_ptr, &info_ptr, NULL);
                   printf( "libpng error\n");
               }
               else
               {
/*                  if ( !png_get_valid( png_ptr, info_ptr, PNG_INFO_bKGD))
 *                  {
 *                     printf( "fails due to no bKGD chunk\n");
 A                     png_destroy_read_struct(&png_ptr, &info_ptr, NULL);
 *                  }
 *                else
 */
                  {
/*** B ***/          png_get_bKGD(png_ptr, info_ptr, &pBackground);

                      /* however, it always returns the raw bKGD data, regardless of any
                       * bit-depth transformations, so check depth and adjust if necessary */

                      if ( bit_depth == 16)
                      {
                          bg_red   = pBackground->red   >> 8;
                          bg_green = pBackground->green >> 8;
                          bg_blue  = pBackground->blue  >> 8;
                      }
                      else if (color_type == PNG_COLOR_TYPE_GRAY && bit_depth < 8)
                      {
                          if (bit_depth == 1)
                              bg_red = bg_green = bg_blue = pBackground->gray? 255 : 0;
                          else if (bit_depth == 2)
                              bg_red = bg_green = bg_blue = (255/3) * pBackground->gray;
                          else /* bit_depth == 4 */
                              bg_red = bg_green = bg_blue = (255/15) * pBackground->gray;
                      }
                      else
                      {
                          bg_red   = (uch)pBackground->red;
                          bg_green = (uch)pBackground->green;
                          bg_blue  = (uch)pBackground->blue;
                      }

                     //  ̹ ͸ о δ.

                     /* setjmp() must be called in every function that calls a PNG-reading
                      * libpng function */

                     if (setjmp(png_jmpbuf(png_ptr)))
                     {
                         png_destroy_read_struct( &png_ptr, &info_ptr, NULL);
                         printf( "ERROR: setjmp(png_jmpbuf(png_ptr)\n");
                     }
                     else
                     {
                        /* expand palette images to RGB, low-bit-depth grayscale images to 8 bits,
                         * transparency chunks to full alpha channel; strip 16-bit-per-sample
                         * images to 8 bits per sample; and convert grayscale to RGB[A] */

                        if (color_type == PNG_COLOR_TYPE_PALETTE)
                            png_set_expand(png_ptr);
                        if (color_type == PNG_COLOR_TYPE_GRAY && bit_depth < 8)
                            png_set_expand(png_ptr);
                        if (png_get_valid(png_ptr, info_ptr, PNG_INFO_tRNS))
                            png_set_expand(png_ptr);
                        if (bit_depth == 16)
                            png_set_strip_16(png_ptr);
                        if (color_type == PNG_COLOR_TYPE_GRAY ||
                            color_type == PNG_COLOR_TYPE_GRAY_ALPHA)
                            png_set_gray_to_rgb(png_ptr);


                        /* unlike the example in the libpng documentation, we have *no* idea where
                         * this file may have come from--so if it doesn't have a file gamma, don't
                         * do any correction ("do no harm") */

                        if (png_get_gAMA(png_ptr, info_ptr, &gamma))
                            png_set_gamma(png_ptr, display_exponent, gamma);


                        /* all transformations have been registered; now update info_ptr data,
                         * get rowbytes and channels, and allocate image memory */

                        png_read_update_info(png_ptr, info_ptr);

                        image_rowbytes = rowbytes = png_get_rowbytes(png_ptr, info_ptr);
                        image_channels = (int)png_get_channels(png_ptr, info_ptr);

                        if ( (image_data = (uch *)malloc(rowbytes*height)) == NULL)
                        {
                            png_destroy_read_struct(&png_ptr, &info_ptr, NULL);
                            printf( "error: image_data = malloc(rowbytes*height)\n");
                        }
                        else
                        {
                           if ( (row_pointers = (png_bytepp)malloc(height*sizeof( png_bytep))) == NULL)
                           {
                               png_destroy_read_struct(&png_ptr, &info_ptr, NULL);
                               free(image_data);
                               printf( "error: row_pointer = malloc(height*sizeof(png_bytep)\n");
                           }
                           else
                           {
                              printf( "readpng_get_image:\n");
                              printf( "  channels = %d\n" , image_channels);
                              printf( "  rowbytes = %ld\n", rowbytes);
                              printf( "  height   = %d\n" , height  );

                              /* set the individual row_pointers to point at the correct offsets */

                              for (i = 0;  i < height; i++)
                                  row_pointers[i] = image_data + i*rowbytes;

                              /* now we can go ahead and just read the whole image */

                              png_read_image( png_ptr, row_pointers);

                              /* and we're done!  (png_read_end() can be omitted if no processing of
                               * post-IDAT text/time/etc. is desired) */

                              free( row_pointers);
                              row_pointers = NULL;

                              png_read_end( png_ptr, NULL);

                              //  ȭ !!

                              {
                                 ulg red, green, blue;
                                 ulg r, g, b, a;
                                 int      row;
                                 int      clrPixel;
                                 uch     *src;

                                 for ( row = 0;  row < height;  ++row)
                                 {
                                    src   = image_data + row*image_rowbytes;
                                    if ( image_channels == 3)
                                    {
                                       for (i = 0; i < width; i++)
                                       {
                                          red   = *src++;
                                          green = *src++;
                                          blue  = *src++;
                                          clrPixel = gx_color( dc, red, green, blue);
                                          gx_set_pixel( dc, i, row, clrPixel);
                                       }
                                    }
                                    else /* if (image_channels == 4) */
                                    {
                                       for (i = 0; i < width; i++)
                                       {
                                           r = *src++;
                                           g = *src++;
                                           b = *src++;
                                           a = *src++;
                                           if (a == 255)
                                           {
                                               red   = r;
                                               green = g;
                                               blue  = b;
                                                clrPixel = gx_color( dc, red, green, blue);
                                                gx_set_pixel( dc, i, row, clrPixel);
                                           } else if (a == 0) {                  //  κ
/*                                              red   = bg_red;
 C                                              green = bg_green;
 *                                              blue  = bg_blue;
 */
                                           } else {
/*                                               /  * this macro (from png.h) composites the foreground
 *                                                  * and background values and puts the result into the
 *                                                  * first argument *  /
 D                                               alpha_composite(red,   r, a, bg_red);
 *                                               alpha_composite(green, g, a, bg_green);
 *                                               alpha_composite(blue,  b, a, bg_blue);
 */
                                           }
                                       }
                                    }
                                 }
                              }
                              // ȭ  
                              png_destroy_read_struct(&png_ptr, &info_ptr, NULL);
                              free(image_data);
                           }
                        }
                     }
                  }
               }
            }
         }
      }
   }

   /* close the file */
   fclose(infile);

   gx_release_dc( dc);                                                           // dc ȯ
   gx_close();                                                                   // ׷ ̺귯  

   return   0;
}
